#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <stdarg.h>
#include <float.h>
#include <poll.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <dirent.h>
#include <arpa/inet.h>
#include <errno.h> 
#include <time.h>
#include <sys/time.h>
#include <inttypes.h>

#define NLENGTH_POSIX_PATH_MAX 4096
#define DEFAULT_BUFLEN_SOCKET_RD 10000000
#define nmaxconcttryping 20
#define nconcttimeoutping 100000
#define POLL_INTERVAL_NONBLOCK 100000
#define nmaxsocketblock_conn 10
#define nmaxsocketblock_ioxfer 300
#define ksocketimeoutsec 0

#define SOCK_DOWN_TERMINATE_LOOPERR_CODE 18
#define KHTTP_SCAN_HEADER_STATUS_NO -2
#define KHTTP_SCAN_HEADER_STATUS_OK -1
#define CODE_HTTP_RECEIVE_STATUS_OK 200
#define SCALING_FACTOR_NANO 1000000000

/*forward declarations */
typedef struct TYPEPTR TYPEPTR;
int main(int ,char *[]);
/*typedef TYPEFNCLOOPSOCKCOMMS ;*/


/*#define ENUMLSTPARAMPATHFILE "cfglist.h"*/
/*#include ENUMLSTPARAMPATHFILE*/




#define addgenericelemarrayseqlist(kelem,nelem,typevecptr,typeptr,ptrelem) \
 nelem++;kelem=nelem-1;\
 ptrelem=(typevecptr) realloc(ptrelem,sizeof(typeptr)*nelem);\



 


typedef  bool TYPECHKPATHFOLDVARS[3];

const char spathdelimiter='\\';

#define NCHRSYNCSOCKETREQUESTPRFX 27
#define NCHRSYNCMAXPROGLENGTH 23
#define NUM_RSYNC_PROG_FILES 2
const char slist_remote_prog_files[NUM_RSYNC_PROG_FILES][NCHRSYNCMAXPROGLENGTH]=
{
"unzip_lnx.bin", 	
"hackinst_tools_lnx.zip"		
};





#define KEOFIMDLST_INT INT32_MIN 
#define KEOFIMDLST_DOUBLE DBL_MIN 


#define kcodrecptr -1




#define nbitsperbyte 8


#define NINIGUESSGETDIRFILES 100


#define NTSTAMPDATA 31

#define NADDRIPLEN 16
typedef char STSTAMPDATA[NTSTAMPDATA];
#define NCHRSSSIDACCNAMVAR 256
#define NCHRILEPERMATTR 5
#define NCHBINARYNUMBER 65

#define SUCCESSFULITERFLAGVAL -1
#define FILETMSCALETO_MS 10000
#define TSCALEFILETIMETOUSECONDS 10
#define TSCALEFILETIMETOMSECONDS 10000
#define TSCALEFILETIMETOSECONDS 10000000
#define TSCALFILETIMETOMIN          600000000
#define TSCALFILETIMETOHRS      36000000000

#define NCHRSSGENERICVAR 1000

#define KDEFAULT_SECTOR_SIZE 512
#define WRITESTREAMINVALIDRES -1

#define INVALID_SOCKET -1
#define INVALID_HANDLE_VALUE -1
#define SOCKET_ERROR -1
#define FILE_TYPE_CHAR 0x0002
#define FILE_TYPE_DISK 0x0001
#define FILE_TYPE_PIPE 0x0003
#define INVALID_STREAM_OFFSET -1
#define INVALID_SET_FILE_POINTER -1
#define NSOCKPOLL 1
#define KCNCTXIP 0
#define NHTTP_ERROR_CODES 1000
#define HTTP_KEEP_ALIVE_TIMEOUT 60
#define HTTP_KEEP_ALIVE_MAXREQ 1000

char khttperrcodemap[NHTTP_ERROR_CODES] = 
{
[503]=19,
[504]=20,
[408]=21, 
[409]=22, 
[425]=23, 
[429]=24
};

#define ConnectSocket isockpoll[KCNCTXIP].fd 

typedef char STRSIDACCNAMVAR[NCHRSSSIDACCNAMVAR];
typedef char STRFILEPERMATTR[NCHRILEPERMATTR];
typedef char STRBINARYNUMBER[NCHBINARYNUMBER];
typedef char STRGENERICVAR[NCHRSSGENERICVAR+1];


typedef struct 
 {  
 STRSIDACCNAMVAR sfilename;
 }  DIRVECDATAWITHSIZE;




typedef uint32_t TYPEINDEX;
typedef int32_t TYPEFRMTREC;

typedef struct pollfd TYPPOLLFD;


typedef struct TYPEIOFDREC
 {
 int ifdin;
 int ifdout;
 int ifderr; 
 int kmodein;
 int kmodeout;
 int kmodeerr; 
 int kftypein;
 int kftypeout; 
 int kftypeerr; 
 TYPPOLLFD ipollcnsin;
 TYPPOLLFD ipollcnsout;
 TYPPOLLFD ipollcnserr;
 }  TYPEIOFDREC;


TYPEINDEX var_kstartmcrrlc;
int  var_salloc_nctoken;



typedef union GENPTRDATA {
   int *k;
   double *x;
   char *s;
   char **ms;
   bool *b;
   DIRVECDATAWITHSIZE *dir;
   struct TYPEPTR *p;
} GENPTRDATA;  

typedef struct TYPEPTR
 {
 TYPEINDEX nelem;
 TYPEFRMTREC ntype;
 GENPTRDATA i;
 }  TYPEPTR;



typedef struct dirent *PVECDIRENT;

const char sdelimcnst_eol[]="\n";

/*
typedef struct TYPEIMGWRTCFG {
} TYPEIMGWRTCFG;
*/
const char char_path_delimiter_posix='/';

const char shttp_header_end_pattern[]="\r\n\r\n";
const char shttp_content_length_info[]="Content-Length:";
const char shttp_receive_status_info[]="HTTP/1.1";
#define nc_http_header_end_pattern 4
const char rsyncclnt_cmdline[]="rsync_clnt_lnx.bin -rptgoD -v -L  --numeric-ids --skip-compress=*  --port=6021 --progress grpcchar.ddns.net::grpcchar_rsync_share/";

const char runasadmin_cmdline[]="sudo ";

const char sremotepath_tools[]="tools/";

const char sfilename_tools_imgwrite[]="imgwrite_lnx.bin";
const char sfilename_tools_decompressor[]="xz_lnx.bin";

char recvbuf[DEFAULT_BUFLEN_SOCKET_RD];
/*TYPEIMGWRTCFG imgwrtcfg;*/
#define imgwrtcfg dummy_top_level_vars
STRGENERICVAR  sbuftmp ;
char *stktmpptr=NULL;
TYPEPTR srawdata;
unsigned int ksockoptval;
char *sktmp;
char *slabmacfullimg;
char sfilemacfullimg;
int nctmpbuf;
double xtotsrcrawdataszprc;
int kdownload;
int iResult;
struct sockaddr_in clientService; 
struct sockaddr_in *pdnsaddrin;
char sendbuf[NLENGTH_POSIX_PATH_MAX]; 
/*char recvbuf[DEFAULT_BUFLEN_SOCKET_RD];*/
struct timeval tv;
fd_set fdset;
fd_set fdrdset;
int so_error;
socklen_t ngetsockoptlen ;
int  kfddownl;
struct addrinfo  idnsreqparams;
struct addrinfo  *pDnsRecord;
long long unsigned int ncdownfilesize;
long long unsigned int kcurdownbytes;
/*long long unsigned int kdownbytesprev;*/
unsigned long pingipaddr;
int kmaxconcttryping;
int kmaxsocketblock;
long long unsigned int ncrequestsize;
long long unsigned int kcurreqbytes;
long long unsigned int kcurreqstart;
double xtbstart;
int kposhtmlhead;
int ncabspath;
DIR *hSearchHandle;
PVECDIRENT findFileData;
struct pollfd isockpoll[NSOCKPOLL];
int knctmp;
char *stoken;
uint16_t khostport;
char *scodename;
long unsigned int ncrawdt;
TYPEIOFDREC iofdrecproc;
TYPEPTR idirvecdata;
STRSIDACCNAMVAR simgfilepath;
char bsockdowncont;



#define mcr_empty_0_rgm {}
#define mcr_empty_1_rgm(par1) {}
#define mcr_empty_2_rgm(par1,par2) {}
#define mcr_empty_3_rgm(par1,par2,par3) {}
#define mcr_empty_5_rgm(par1,par2,par3,par4,par5) {}
#define mcr_empty_12_rgm(par1,par2,par3,par4,par5,par6,par7,par8,par9,par10,par11,par12) {}


#define mcr_empty_1_true(par1) 1
#define mcr_empty_1_false(par1) 0
#define mcr_empty_3_true(par1,par2,par3) 1

#define mcr_decision_tree_singlecode_2_2(cond1,cond2,val11,val12,val21,val22,codeloop11,codeloop12,codeloop21,codeloop22,bodyloop,...) \
if (cond1) \
 {\
 if (cond2) {bodyloop(codeloop11,val11,val12,__VA_ARGS__)}\
 else {bodyloop(codeloop12,val11,val22,__VA_ARGS__)}\
 }\
else \
 {\
 if (cond2) {bodyloop(codeloop21,val21,val12,__VA_ARGS__)}\
 else {bodyloop(codeloop22,val21,val22,__VA_ARGS__)}\
 }


#define  outputdbg(...) \
{printf(__VA_ARGS__);fflush(stdout);}

#define fncgeneric_for_loop_wrap_excte(kgenlpwrexct,kstart,ngenlpwrexct,kstep,fncloopwrpbodyexc)\
{\
for ( kgenlpwrexct=kstart ; kgenlpwrexct<ngenlpwrexct; kgenlpwrexct=kgenlpwrexct+kstep)\
 {\
 fncloopwrpbodyexc \
 }\
}

double xtbpold,xtbpcur,xtbplastdur;
#define writeoutputcputimefromprgstart \
{\
xtbpcur=(float) clock()/(float) CLOCKS_PER_SEC;\
xtbplastdur=xtbpcur-xtbpold;\
xtbpold=xtbpcur;\
}

struct timespec itime_prev;
struct timespec itime_curr;
struct timespec itime_elapsed;
struct timespec itime_start;

#define	timespecsub(tsp, usp, vsp)					\
	 {								\
		(vsp).tv_sec = (tsp).tv_sec - (usp).tv_sec;		\
		(vsp).tv_nsec = (tsp).tv_nsec - (usp).tv_nsec;	\
		if ((vsp).tv_nsec < 0) {				\
			(vsp).tv_sec--;				\
			(vsp).tv_nsec += 1000000000L;			\
		}							\
	} 

#define retrieve_real_time_current \
clock_gettime(CLOCK_MONOTONIC,&itime_curr);\

#define copy_real_time_data_vars(itime_out,itime_in) \
memcpy(&itime_out,&itime_in,sizeof(struct timespec));

#define fmath_subtract_timespec_values(itime_in,itime_sub,itime_res) \
timespecsub(itime_in, itime_sub, itime_res)

#define retrieve_real_time_elapsed \
retrieve_real_time_current \
fmath_subtract_timespec_values(itime_curr,itime_prev,itime_elapsed);\
copy_real_time_data_vars(itime_prev,itime_curr)

#define retrieve_real_time_from_start  \
retrieve_real_time_current \
fmath_subtract_timespec_values(itime_curr,itime_start,itime_elapsed);\

#define retrieve_real_time_set_start \
retrieve_real_time_current \
copy_real_time_data_vars(itime_start,itime_curr)

#define fmath_calc_rate_fractional(kelems,itime) (SCALING_FACTOR_NANO* (double) kelems/(double) (SCALING_FACTOR_NANO*itime.tv_sec+itime.tv_nsec))

#define fmath_calc_time_fractional(itime) ((double) itime.tv_sec+(double) itime.tv_nsec/SCALING_FACTOR_NANO)

#define printdbgwithchknul_nelem(sformatstr,ichkvar) {if (ichkvar) printf(sformatstr,(ichkvar)->nelem);}



#define checkvalidfilehandle(ifiletst) (ifiletst!=-1)



#define mcr_extrbitfromseq(kseqvalue, kbitpos) ((kseqvalue >> kbitpos) & 1)

#define setbitinbinaryseq(kbinseq, kbitval, kbitpos) \
{\
kbinseq=(kbinseq&~(1<<kbitpos))|(kbitval<<kbitpos);\
}

#define mcr_frmtconv_int_binarystring( kvarintg,sbinary, nbitconv,kmsbpos,kbitpos) \
{\
kmsbpos=0;\
/*printf("%d %d ",kvarintg,nbitconv);;outputdbg("start frmtconv_int_binarystring \n");*/\
for (kbitpos=0;kbitpos<nbitconv;kbitpos++)\
 {\
 if (mcr_extrbitfromseq(kvarintg,kbitpos))\
  {\
  (sbinary)[kbitpos]=49;\
  kmsbpos=kbitpos;\
  }\
 else (sbinary)[kbitpos]=48; \
/* printf("%d %d %c %d ",kbitpos,mcr_extrbitfromseq(kvarintg,kbitpos),(sbinary)[kbitpos],kmsbpos);outputdbg("loop frmtconv_int_binarystring \n");*/\
 }\
/*printf("%d %s\n end frmtconv_int_binarystring",kmsbpos,sbinary);*/\
(sbinary)[kmsbpos+1]='\0';\
}

#define dealcrawptrwithchknul(ptrelem) if (ptrelem)  free(ptrelem);
#define dealctypptrwithchknul(ptrelem) if ((ptrelem).nelem)  free((ptrelem).i.s);

#define declare_printbinarystring_vars \
STRBINARYNUMBER sbinary;\
declare_frmtconv_binarystring_int_vars

#define printbinarystring(kvarintg)\
{/* printf("%d %d printbinarystring start\n",sizeof(kvarintg),sizeof(sbinary));*/\
mcr_frmtconv_int_binarystring(kvarintg,sbinary,sizeof(kvarintg)*nbitsperbyte,kmsbpos,kbitpos);\
printf("%s",sbinary);\
}


#define declare_frmtconv_binarystring_int_vars \
int kmsbpos;\
int kbitpos;


#define frmtconv_binarystring_int(sbinary,kvarintg,nbitconv) \
{kmsbpos=0;\
for (kbitpos=0;kbitpos<nbitconv;kbitpos++)\
 {\
 if ((sbinary)[kbitpos]==49)\
  {\
  setbitinbinaryseq(kvarintg,1, kbitpos);\
  kmsbpos=kbitpos;\
  }\
 else setbitinbinaryseq(kvarintg,0, kbitpos);\
 }\
}


#define frmtconv_encfgbtrpartyp_int(kpartyp) ((int) kpartyp)

#define frmtconv_enprcjobstatustyp_int(kprcjobstatus) ((int) kprcjobstatus)


#define setmaskintvalinlongint(kvalue, bmasklow) \
(bmasklow ? ((int64_t) kvalue) << 32 : (int64_t) kvalue)
/*
(((int64_t) (bmasklow)&&(((int64_t) kvalue) << 32)) \
||(!((int64_t)(bmasklow))&&((int64_t) kvalue)))
*/

#define getmaskintvalinlongint(kvalue, bmasklow) \
(bmasklow ? ((int64_t) kvalue) >> 32 : (int64_t) kvalue)
/*(((bmasklow)&&((kvalue) >> 32))||(!(bmasklow)&&(kvalue)))*/


#define prefillvectfollowindex(kscan,vecnumptr,kstart,kstop ) \
{\
for (kscan=kstart;kscan<=kstop;kscan++) (vecnumptr)[kscan]=kscan;\
}

#define swapvarvalueselements(var1,var2,vaux ) \
{\
vaux=var1;var1=var2;var2=vaux;\
}


#define fmath_compare_longint( kval1,  kval2,kout) \
{\
outputdbg("fmath_compare_longint start %ld %ld\n",kval1,kval2);\
if (kval1>kval2) kout=1;\
else \
 {\
 if (kval1<kval2) kout=-1;\
 else kout=0;\
 }\
outputdbg("fmath_compare_longint end %d\n",kout);\
}

#define fmath_compare_double(xval1,  xval2,kout) \
{ \
if (xval1>xval2) kout=1;\
else \
 {\
 if (xval1<xval2) kout=-1;\
 else kout=0;\
 }\
}

#define fmath_outofclosedrange_int( kval,  kmin,  kmax) \
(((kval)<=(kmin))||((kval)>=(kmax)))

#define fmath_outofclosedrange_asgn_int(kval,  kmin,  kmax, kdefault,kout) \
{\
if (fmath_outofclosedrange_int(kval,kmin, kmax)) kout=kdefault;\
}
#define fmath_intrange_to_intnelems(kstart,kstop) ((kstop)+1-(kstart))

#define fmath_limitmaxval_int(kval,  kmax,kdefault)\
{\
if ((kval)>(kmax)) kval=kdefault;\
}

#define fmath_limitminval_int(kval,  kmin,kdefault)\
{\
if ((kval)<(kmin)) kval=kdefault;\
}


#define fmath_minval_int( kval1,  kval2,kout)\
{\
if ((kval1)<(kval2)) kout=kval1;else kout=kval2;\
}

#define fmath_limit_cmp_val_int(kval,  knew, kmax,bresult)\
{\
if ((knew)<=(kmax)) \
 {kval=knew;bresult=false;}\
else \
 {kval=kmax;bresult=true;}\
}

#define declare_fmath_max_vec_int_vars\
int kelemfmaxvec;\

#define fmath_max_vec_int(ivecdata,kmax)\
{\
kmax=(ivecdata).i.k[0];\
for (kelemfmaxvec=1;kelemfmaxvec<(ivecdata).nelem;kelemfmaxvec++)\
 {\
 if ((ivecdata).i.k[kelemfmaxvec]>kmax) kmax=(ivecdata).i.k[kelemfmaxvec];\
 }\
}

#define declare_fmath_min_vec_int_vars\
int kelemfminvec;\

#define fmath_min_vec_int(ivecdata,kmin)\
{\
kmin=(ivecdata).i.k[0];\
for (kelemfminvec=1;kelemfminvec<(ivecdata).nelem;kelemfminvec++)\
 {\
 if ((ivecdata).i.k[kelemfminvec]<kmin) kmin=(ivecdata).i.k[kelemfminvec];\
 }\
}

#define declare_fmath_max_vec_double_vars\
int kelemfmaxvec;

#define fmath_max_vec_double(ivecdata,xmax)\
{\
xmax=(ivecdata).i.x[0];\
for (kelemfmaxvec=1;kelemfmaxvec<(ivecdata).nelem;kelemfmaxvec++)\
 {\
 if ((ivecdata).i.x[kelemfmaxvec]>xmax) xmax=(ivecdata).i.x[kelemfmaxvec];\
 }\
}

#define declare_ fmath_min_vec_double_vars\
int kelemfminvec;\

#define fmath_min_vec_double(ivecdata,xmin)\
{\
xmin=(ivecdata).i.x[0];\
for (kelemfminvec=1;kelemfminvec<(ivecdata).nelem;kelemfminvec++)\
 {\
 if ((ivecdata).i.x[kelemfminvec]<xmin) xmin=(ivecdata).i.x[kelemfminvec];\
 }\
}


#define  checkrecursiveptrstruct(recelem) ((recelem).ntype==kcodrecptr)

#define  updallocindexscan(kelem,nelem,nappend) {nelem=(kelem)+(nappend);}

#define  updallocindexincr(kelem,nelem, nappend) {kelem=nelem;(nelem)+=nappend;}

#define  fnmacroreallocnormmem(ptrelem, nbyteelem) \
 {\
 ptrelem=realloc(ptrelem,nbyteelem); \
 }

#define  chkcondptralloc_size( kelem, nelem,nappend) (((kelem)+(nappend))!=(nelem))

#define  chkcondptralloc_add( kelem, nelem,nappend) (((kelem)+(nappend))>(nelem))



#define storebytememptr(ptrelem, nbyteelem, cinitval) \
 {\
/* printf("%lu %d ",nbyteelem,cinitval);outputdbg("storebytememptr\n");*/\
 memset(ptrelem, cinitval, nbyteelem);\
 }


#define copymemscan(ptrelem,ptrsource, nbyteelem,kdeststart,ksrcstart) \
 {\
 /*printf("%d %d ",nbyteelem,kdeststart);outputdbg("copymemscan\n");*/\
 memcpy((void *)  &ptrelem[kdeststart], ptrsource, nbyteelem);\
 }

#define copy_storenbyte_memscan(ptrelem,ptrsource, nbyteelem,kdeststart,ksrcstart) \
 {\
 var_kstartmcrrlc=nbyteelem;\
 /*printf("%d %d ",var_kstartmcrrlc,kdeststart);outputdbg("copy_storenbyte_memscan\n");*/\
 copymemscan(ptrelem, ptrsource, var_kstartmcrrlc,kdeststart,0);\
 }

#define copy_storebstart_memscan(ptrelem,ptrsource, nbyteelem,kdeststart,ksrcstart) \
 {\
 var_kstartmcrrlc=kdeststart;\
 /*printf("%d %d ",nbyteelem,var_kstartmcrrlc);outputdbg("copy_storebstart_memscan\n");*/\
 copymemscan(ptrelem, &(ptrsource)[var_kstartmcrrlc], nbyteelem,var_kstartmcrrlc,0);\
 }

#define copy_splitstart_memscan(ptrelem,ptrsource, nbyteelem,kdeststart,ksrcstart) \
 {\
 /*printf("%d %d ",nbyteelem,var_kstartmcrrlc);outputdbg("copy_storebstart_memscan\n");*/\
 copymemscan(ptrelem, &(ptrsource)[ksrcstart], nbyteelem,kdeststart,0);\
 }


#define copymemscanempty(ptrelem,ptrsource, nbyteelem,kdeststart,ksrcstart)  { }

#define  setrecordptrtype(recelem, ktyperec)\
 {\
 (recelem).ntype=ktyperec;\
 }



#define  fnmacroreallocscannormmem(recelem,kelem, nsizeelem, nappend, inewval, nelemcpy, ktyperec,  funccheckalloc,funcupdateindex,funcinitmem,funcassignmem,krlcstart,funcsetrectype ) \
 {\
/* printf("nelem=%d kelem=%d nsizeelem=%d nappend=%d   nelemcpy=%d ktyperec=%d ",(recelem).nelem,kelem,nsizeelem,nappend,nelemcpy,ktyperec);if (inewval) printf("inewval=%s" ,(char *) inewval);outputdbg("fnmacroreallocscannormmem\n");*/\
 funcsetrectype(recelem,ktyperec);\
 if (funccheckalloc(kelem,(recelem).nelem,nappend))\
  {\
  funcupdateindex(kelem,(recelem).nelem,nappend);\
/*  printf("nelem=%d kelem=%u nappend=%d\n",recelem->nelem,*kelem,nappend);outputdbg("funcupdateindex fnmacroreallocscannormmem\n");*/\
  fnmacroreallocnormmem((recelem).i.s,(recelem).nelem*(nsizeelem));\
  }  \
/*  printf("AsI %d %u %u ",recelem->nelem,nsizeelem*kstart,(recelem->nelem-kstart)*nsizeelem);outputdbg("mmini\n");*/\
  funcinitmem((void *) &(recelem).i.s[krlcstart*(nsizeelem)],((recelem).nelem-krlcstart)*(nsizeelem),(int) nelemcpy);    \
/*  printf("AsL %u %u ",nsizeelem*kstart,nelemcpy*nsizeelem);outputdbg("mmcpy\n");*/\
 funcassignmem( (recelem).i.s,inewval,(nelemcpy)*(nsizeelem),(nsizeelem)*krlcstart,(kelem)*(nsizeelem));    \
 }

#define  initptrstructure(ptrelem) \
{\
ptrelem=(TYPEPTR) {0,0,{NULL}};\
/*ptrelem->nelem=0;\
ptrelem->ntype=0;\
ptrelem->i.s=NULL;*/\
}

void  deleteloopptrstructure(TYPEPTR *ptrelem) 
{
TYPEINDEX kelem;
if (checkrecursiveptrstruct(*ptrelem))
 {
/* printf("FDREC %u\n",ptrelem->nelem);outputdbg("FDREC\n");*/
 for (kelem=0;kelem<ptrelem->nelem;kelem++)
  {
/*  printf("FRP %u\n",kelem);outputdbg("FRP\n");*/
  deleteloopptrstructure(&ptrelem->i.p[kelem]);
  }
 }
/*printf("FRN %u\n",ptrelem->nelem);outputdbg("FRN\n");*/
dealctypptrwithchknul(*ptrelem) 
}

#define  deleteptrstructure(ptrelem) \
{\
deleteloopptrstructure(&ptrelem); \
initptrstructure(ptrelem);\
}

#define  deletepvecstructure(ptrelem) \
{\
deleteptrstructure(*(ptrelem)) ;\
free(ptrelem);(ptrelem)=NULL;\
}


#define  rlcincrec(recelem,kelem, nsizeelem, nappend) \
{\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,nappend,NULL,0,0,mcr_empty_3_true,updallocindexincr,mcr_empty_3_rgm,copymemscanempty,0,mcr_empty_2_rgm); \
}

#define  rlcupdrec(recelem,  kelem, nsizeelem) \
{\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,0,NULL,0,0,chkcondptralloc_size,updallocindexscan,mcr_empty_3_rgm,copymemscanempty,0,mcr_empty_2_rgm); \
}

#define  rlcincptr(recelem,kelem, nappend) \
{\
fnmacroreallocscannormmem(recelem,kelem,sizeof(TYPEPTR),nappend,NULL,0,kcodrecptr,mcr_empty_3_true,updallocindexincr,mcr_empty_3_rgm,copymemscanempty,0,setrecordptrtype); \
}

#define  rlcupdptr(recelem,  kelem) \
{\
fnmacroreallocscannormmem(recelem,kelem,sizeof(TYPEPTR),0,NULL,0,kcodrecptr,chkcondptralloc_size,updallocindexscan,mcr_empty_3_rgm,copymemscanempty,0,setrecordptrtype); \
}

#define  rlcaddrec(recelem,  kelem, nsizeelem) \
{\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,0,NULL,0,0,chkcondptralloc_add,updallocindexscan,mcr_empty_3_rgm,copymemscanempty,0,mcr_empty_2_rgm); \
}

#define  rlcaddptr(recelem,  kelem) \
{\
fnmacroreallocscannormmem(recelem,kelem,sizeof(TYPEPTR),0,NULL,0,kcodrecptr,chkcondptralloc_add,updallocindexscan,mcr_empty_3_rgm,copymemscanempty,0,setrecordptrtype); \
}



#define  clcincrec(recelem,kelem, nsizeelem, nappend, nelemcpy) \
{var_kstartmcrrlc=(recelem).nelem;\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,nappend,NULL,nelemcpy,0,mcr_empty_3_true,updallocindexincr,storebytememptr,copymemscanempty,var_kstartmcrrlc,mcr_empty_2_rgm); \
}

#define  clcupdrec(recelem,  kelem, nsizeelem, nelemcpy) \
{\
if (!(recelem).nelem) \
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,0,NULL,nelemcpy,0,chkcondptralloc_size,updallocindexscan,storebytememptr,copymemscanempty,0,mcr_empty_2_rgm); \
}

#define  clcincptr(recelem,kelem, nappend) \
{var_kstartmcrrlc=(recelem).nelem;\
fnmacroreallocscannormmem(recelem,kelem,sizeof(TYPEPTR),nappend,NULL,0,kcodrecptr,mcr_empty_3_true,updallocindexincr,storebytememptr,copymemscanempty,var_kstartmcrrlc,setrecordptrtype); \
}

#define  clcupdptr(recelem,  kelem) \
{\
if (!(recelem).nelem) \
fnmacroreallocscannormmem(recelem,kelem,sizeof(TYPEPTR),0,NULL,0,kcodrecptr,chkcondptralloc_size,updallocindexscan,storebytememptr,copymemscanempty,0,setrecordptrtype); \
}


#define  cpyincrec(recelem,kelem, nsizeelem,inewval, nelemcpy) \
{var_kstartmcrrlc=(recelem).nelem;\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,nelemcpy,inewval,nelemcpy,0,mcr_empty_3_true,updallocindexincr,mcr_empty_3_rgm,copymemscan,var_kstartmcrrlc,mcr_empty_2_rgm); \
}

#define  cpyupdrec(recelem,  kelem, nsizeelem, inewval, nelemcpy) \
{\
fnmacroreallocscannormmem(recelem,kelem,nsizeelem,0,inewval,nelemcpy,0,chkcondptralloc_size,updallocindexscan,mcr_empty_3_rgm,copymemscan,0,mcr_empty_2_rgm); \
}


#define  cpyaddrec(recelem,kdeststart, nsizeelem,inewval, nelemcpy,copyfncmemelems,ksrcstart) \
{outputdbg("cpyaddrec %d %d %d %d %d \n",(recelem).nelem,ksrcstart,kdeststart,nsizeelem,nelemcpy);\
fnmacroreallocscannormmem(recelem,kdeststart,nsizeelem,nelemcpy,inewval,nelemcpy,0,chkcondptralloc_add,updallocindexscan,mcr_empty_3_rgm,copyfncmemelems,ksrcstart,mcr_empty_2_rgm); \
}




#define mcr_strpcat_unary(sorigptr,sappndptr,kstart,ncpyelem,knctmp) \
{\
cpyincrec(sorigptr,knctmp,sizeof(char),&(sappndptr)[kstart],ncpyelem-kstart); \
}


#define setkedgevecrangecompfull(kstart,kstop,nelem)\
{/*printf("%d %d %d ",kstart,kstop,nelem);outputdbg("start setkedgevecrangecompfull\n");*/\
fmath_outofclosedrange_asgn_int(kstart, -1, nelem,0,kstart);\
fmath_outofclosedrange_asgn_int(kstop, -1, nelem,nelem-1,kstop);\
if ((kstart)>(kstop)) kstop=kstart;\
/*printf("%d %d ",kstart,kstop);outputdbg("end setkedgevecrangecompfull\n");*/ \
}

#define checkptrvalidandnotempty(iwriteptr) (!(iwriteptr)||(!(iwriteptr)->nelem))

#define checkptrbinaryvalidandnotempty(iwriteptr1,iwriteptr2)  (checkptrvalidandnotempty(iwriteptr1)||checkptrvalidandnotempty(iwriteptr2))

#define checkunryargprintdebug(iwriteptr,kstart,kstop,bresult)\
{\
if (checkptrvalidandnotempty(iwriteptr)) bresult=true;\
else \
 {\
 setkedgevecrangecompfull(kstart,kstop,(iwriteptr)->nelem);\
 bresult=false;\
 }\
}





#define checkvldopsizvarparam(kopsizvar) (kopsizvar>0)


#define test_alphabetical_lowercase_chr( strintchar) ((strintchar>96)&&(strintchar<123))

#define test_alphabetical_uppercase_chr( strintchar) ((strintchar>64)&&(strintchar<91))



#define  test_alphabetical_character( strintchar)  (test_alphabetical_lowercase_chr(strintchar)||test_alphabetical_uppercase_chr( strintchar))

#define test_numeric_character( strintchar) ((strintchar>47)&&(strintchar<58))


#define test_alphanumeric_character( strintchar) (test_alphabetical_character(strintchar)||test_numeric_character(strintchar))

#define test_printable_character( strintchar) ((strintchar>=32)&&(strintchar<=126))

#define chkdebugalphanumeric(strdebug, kstart, ndebug,bresult,kdebug) \
{\
for (kdebug=kstart;kdebug<ndebug;kdebug++) \
 if (((strdebug[kdebug]<32)||(strdebug[kdebug]>126))&&\
 (!((strdebug[kdebug]==13)||(strdebug[kdebug]==10)||(strdebug[kdebug]==9)))) \
  break;\
bresult=(kdebug==ndebug);\
}


#define test_printable_character_nospc( strintchar) ((strintchar>32)&&(strintchar<=126))


#define replace_http_filename_non_printable(sfilename,ncfilename,kncsrc,knctrgt,stmpbuf) \
{\
knctrgt=0;\
if (ncfilename) for (knctmp=0;knctmp<ncfilename;knctmp++)\
 {\
 if (test_printable_character_nospc(sfilename[knctmp]))\
  {\
  stmpbuf[knctrgt]=sfilename[knctmp];knctrgt++;\
  }\
 else\
  {\
  knctrgt+=sprintf(&stmpbuf[knctrgt],"%%%02x",sfilename[knctmp]);\
  }\
 }\
stmpbuf[knctrgt]='\0';\
} 


#define printdebugoutputstring(strmsg,strdebug, kstart, ndebug,bresult,kdebug)\
{\
printf("%s : ",strmsg);\
chkdebugalphanumeric(strdebug,kstart,ndebug,bresult,kdebug)\
if (bresult) \
for (kdebug=kstart;kdebug<ndebug;kdebug++) printf("%c",strdebug[kdebug]);\
 else {printf("BIN : ");\
for (kdebug=kstart;kdebug<ndebug;kdebug++) printf("%d ",strdebug[kdebug]);}\
printf("\n");fflush(stdout);\
}


int knc_vcptrftmp;
FILE *kfd_vcptrftmp;

#define s_intrnl_vecprintf(sdestptr,sptrwithoffs,sprepndstr,ncptrwithoffs,nchprepndstr,fvecprntfnccpyprependstr, ...) \
{\
kfd_vcptrftmp=fopen("/dev/null", "w");\
knc_vcptrftmp=fprintf(kfd_vcptrftmp,__VA_ARGS__)+1;\
fclose(kfd_vcptrftmp);\
/*outputdbg("svecprintf %d \n",knc_vcptrftmp);*/\
if (ncptrwithoffs>1)\
 {\
 rlcupdrec((sdestptr),ncptrwithoffs,sizeof(char));\
 fvecprntfnccpyprependstr(sptrwithoffs,sprepndstr,nchprepndstr) ; \
/*  outputdbg("svecprintf %d %s \n",sdestptr->nelem,sformat);*/\
 snprintf(sptrwithoffs,knc_vcptrftmp,__VA_ARGS__);\
 }\
}


#define svecprintf(sdestptr, ...) \
{\
s_intrnl_vecprintf(sdestptr,(sdestptr).i.s,NULL,knc_vcptrftmp,0,mcr_empty_3_rgm, __VA_ARGS__) \
}

#define spcatvecprintf_noprep(sdestptr,kstart, ...) \
{\
s_intrnl_vecprintf(sdestptr,&(sdestptr).i.s[kstart],NULL,((kstart)+knc_vcptrftmp),0,mcr_empty_3_rgm, __VA_ARGS__) \
}


#define spcatvecprintf_rpct_1(sdestptr,sprepstr,ncprepstr, ...) \
{\
s_intrnl_vecprintf(sdestptr,&(sdestptr).i.s[ncprepstr],sprepstr,((ncprepstr)+knc_vcptrftmp),ncprepstr,memcpy, __VA_ARGS__) \
}

/*
#define readinputfileunformatted(sfileread,srawdata,kfstart,berrproc) \
{\
berrproc=0;\
kfdrawdt=open(sfileread,O_RDONLY);\
if (kfdrawdt>=0) \
 {\
 kunformfilesz=mcr_streamioraw_static_seek(kfdrawdt, 0, SEEK_END);\
 ncrawdt=kunformfilesz-kfstart;\
 rlcupdrec(srawdata,ncrawdt+1,sizeof(char));\
 mcr_streamioraw_static_seek(kfdrawdt, kfstart, SEEK_SET);\
 read(kfdrawdt, (srawdata).i.s, ncrawdt);\
 (srawdata).i.s[ncrawdt]='\0';\
 close(kfdrawdt);\
 }\
else\
 {\
 printf("ERROR: input file %s open error,aborting\n",sfileread);berrproc=1;\
 }\
}
*/

#define writeflushfilestream(kfdout,strout,ncsout,dwwrite,lpoverlapped,berrproc) \
fsync(kfdout);\
dwwrite=write( \
 kfdout, \
 strout, \
 ncsout \
 );\
berrproc=(dwwrite!=WRITESTREAMINVALIDRES);\
fsync(kfdout);

#define declare_getlocaltimefromtmstrct_vars \
time_t timer_stamp;\
struct tm* tm_info_stamp;


#define getlocaltimefromtmstrct(timer_stamp,tm_info_stamp) \
{\
time(&timer_stamp);\
tm_info_stamp = localtime(&timer_stamp);\
}

#define fuctcallocatetimestamp(sltimestamp)\
{\
getlocaltimefromtmstrct(timer_stamp,tm_info_stamp) \
strftime(sltimestamp, 25, "%Y_%m_%d_%H_%M_%S", tm_info_stamp);\
}

#define declare_writelogmsg_vars \
int dwwrite_wrlog;\
int nctmpbuf_wrlog;\
STSTAMPDATA scurtstamp_wrlog;\
int kfdout_wrlog;\
size_t errmsgsize;\
int berrflag;\
STRGENERICVAR stmpbuf_wrlog;\
/*initptrstructure(stmpbuf_wrlog);\
declare_getlocaltimefromtmstrct_vars \
TYPEPTR stmpbuf_wrlog;*/

#define writelogmsg(kfdlog,...) \
{\
/*if (slogmsg) printf("%d ",strlen(slogmsg));outputdbg("start writelogmsg\n");*/\
/*fuctcallocatetimestamp(scurtstamp_wrlog);\
dwwrite_wrlog=strlen(scurtstamp_wrlog);\
spcatvecprintf_rpct_1(stmpbuf_wrlog,scurtstamp_wrlog,dwwrite_wrlog,__VA_ARGS__) \*/\
nctmpbuf_wrlog=sprintf(stmpbuf_wrlog,__VA_ARGS__);\
if (checkvalidfilehandle ( kfdlog)) kfdout_wrlog=kfdlog;\
else kfdout_wrlog=STDOUT_FILENO;\
writeflushfilestream( \
 kfdout_wrlog, \
 stmpbuf_wrlog, \
 nctmpbuf_wrlog, \
 dwwrite_wrlog, \
 NULL,\
 berrflag\
 );\
/* printf("%s %d %d %d %d ",stmpbuf.i.s,dwwrite,stmpbuf.nelem,strlen(stmpbuf.i.s),checkvalidfilehandle (kfdlog));outputdbg(" writtenlogdata\n");*/\
/*outputdbg("\nend writelogmsg\n");*/\
/*deleteptrstructure(stmpbuf_wrlog);*/\
}

#define printerrorcodeproc( errorMessageID)\
{\
printf(" ERRORMSG: %d %s\n",errorMessageID,strerror(errorMessageID));\
}

#define writeerrormsg(kfdlog,...) \
{\
writelogmsg(kfdlog,__VA_ARGS__);/*perror(" ");*/\
printerrorcodeproc(errno);\
fflush(stderr);\
}







#define mcr_iotransfrdata_write_stream( sbufout, kfdwrite,soutptr,kstart,ncpyelem,nsizeelem,berrproc,dwwrite)\
{ \
if (checkvalidfilehandle(kfdwrite)) \
 {\
 writeflushfilestream( \
  kfdwrite, \
  &sbufout[kstart*nsizeelem], \
  (ncpyelem)*nsizeelem, \
  dwwrite, \
  NULL,\
  berrproc\
  );\
 if (((berrproc)==0)||(dwwrite==0)) \
  { \
  writeerrormsg(INVALID_HANDLE_VALUE,"fnc_iotransfrdata_write_stream failed");\
  }\
 }\
}

#define declare_iotransfrdata_loop_vars \
int berrproc;\
int dwiotkn;\
declare_writelogmsg_vars







#define declare_printdebugixstritem_loop_vars \
int kctoken;\
int ktkstart;\
bool bresult;

#define declare_fncprintdebuggnptrdat_scan_vars \
declare_printdebugixstritem_loop_vars \
int nctoken;



#define mcr_printdebugixstritem_int_loop(iptrdebug, kstart, kstop,nsizeelem,ikmap, kctoken,mcr_printdebugixstritem_output,soutptr,ktkstart,mcr_ntkelem,dwwrite,kmptoken,icmpchkvec)\
{\
checkunryargprintdebug(icmpchkvec,kstart,kstop,bresult);\
if (!bresult) \
 {\
 ktkstart=0;\
 /*printf("%\nd %d ",dwwrite, nsizeelem);outputdbg("start mcr_printdebugixstritem_int_loop\n");*/\
 rlcupdrec(*soutptr,  dwwrite, nsizeelem) \
 for (kctoken=kstart;kctoken<=kstop;kctoken++) \
  {\
  mcr_printdebugixstritem_output(kmptoken,&soutptr->i.s[ktkstart]) ; \
  /*printf("%d %d %d %d ",kctoken,kmptoken,ktkstart,mcr_ntkelem(kmptoken));if (ikmap) printf("MAP %d ",ikmap[kctoken]);outputdbg("iter mcr_printdebugixstritem_int_loop\n");*/\
  ktkstart+=mcr_ntkelem(kmptoken)+1; \
  soutptr->i.s[ktkstart-1]='\t';\
  }\
 soutptr->i.s[ktkstart-1]='\0';\
 rlcupdrec(*soutptr,  ktkstart, 1) \
 }\
}


#define mcr_decision_tree_singlecode_1_2(cond,val1,val2,codeloop1,codeloop2,bodyloop,...) \
if (cond) \
 {\
 bodyloop(codeloop1,val1,__VA_ARGS__)\
 }\
else \
 {\
 bodyloop(codeloop2,val2,__VA_ARGS__)\
 }

#define bodymac_printdebugixstritem_loop(codemapd,kmptoken,mcr_printdebugixstritem_output,icmpchkvec,mcr_ntkelem,nsizeelem,dwwrite) \
codemapd(iptrdebug, kstart, kstop,nsizeelem,ikmap, kctoken,mcr_printdebugixstritem_output,soutptr,ktkstart,mcr_ntkelem,dwwrite,kmptoken,icmpchkvec) 


#define mcr_printdebugixstritem_loop(iptrdebug,kstart,kstop,ikmap,kctoken,mcr_printdebugixstritem_output,soutptr,ktkstart,mcr_ntkelem,dwwrite,icmpchkvec,nsizeelem) \
{ \
mcr_decision_tree_singlecode_1_2(!(ikmap),kctoken,ikmap[kctoken],mcr_printdebugixstritem_int_loop,mcr_printdebugixstritem_int_loop,bodymac_printdebugixstritem_loop,mcr_printdebugixstritem_output,icmpchkvec,mcr_ntkelem,nsizeelem,dwwrite) \
}


void fncprintdebuggnptrdata_index_filename(TYPEPTR *iptrdebug,int kstart,int kstop,int *ikmap,TYPEPTR *soutptr)
{
declare_fncprintdebuggnptrdat_scan_vars
/*#define bodymac_fncprintdebuggnptrdata_filename_sbufout(kmptoken) sbufout*/
#define bodymac_fncprintdebuggnptrdata_index_filename_ntkelem(kmptoken)  nctoken
#define bodymac_fncprintdebuggnptrdata_index_filename(kmptoken,sbufout) \
nctoken=sprintf(sbufout,"\r%d %s\n",kmptoken,iptrdebug->i.dir[kmptoken].sfilename);\
/*outputdbg("fncprintdebuggnptrdata_filename ");*/

mcr_printdebugixstritem_loop(iptrdebug,kstart,kstop,ikmap,kctoken,bodymac_fncprintdebuggnptrdata_index_filename,*soutptr,ktkstart,bodymac_fncprintdebuggnptrdata_index_filename_ntkelem,fmath_intrange_to_intnelems(kstart,kstop),iptrdebug,NCHRSSGENERICVAR);
}



#define declare_printdebugvector_vars \
declare_iotransfrdata_loop_vars \
TYPEPTR spdbgoutptr;\
initptrstructure(spdbgoutptr);


#define mcr_printdebugvector(iptrdebug,kstart, kstop,ikmap,fncprintdebuggnptrdata,iotransfrdata_write,kfdwrite,soutptr,berrproc,dwiotkn)\
{\
deleteptrstructure(soutptr) \
fncprintdebuggnptrdata(iptrdebug,kstart,kstop,ikmap,&soutptr);\
if ((soutptr).nelem)\
 {\
 iotransfrdata_write((soutptr).i.s,kfdwrite,NULL,0,(soutptr).nelem-1,sizeof(char),berrproc,dwiotkn);\
 }\
}


#define mcr_frmt_printdebuggnptrdata(iptrdebug,kstart,kstop,ikmap,fncprintdebuggnptrdata,iotransfrdata_write,kfdwrite,soutptr,berrproc,dwiotkn,kpartyp) \
{\
deleteptrstructure(*soutptr) \
fncprintdebuggnptrdata[kpartyp](iptrdebug,kstart,kstop,ikmap,soutptr);\
}

#define mcr_printdebuggnptrdata(iptrdebug,kstart, kstop,ikmap,fncprintdebuggnptrdata,iotransfrdata_write,kfdwrite,soutptr,berrproc,dwiotkn,kpartyp) \
{\
mcr_frmt_printdebuggnptrdata(iptrdebug,kstart, kstop,ikmap,fncprintdebuggnptrdata,iotransfrdata_write,kfdwrite,&soutptr,berrproc,dwiotkn,kpartyp); \
iotransfrdata_write((soutptr).i.s,kfdwrite,NULL,0,(soutptr).nelem,sizeof(char),berrproc,dwiotkn);\
}



#define extractabsolutepath( sfilepath,sabspath)\
{\
sktmp=NULL;\
memcpy(sabspath,sfilepath,sizeof(STRSIDACCNAMVAR));\
sktmp=strrchr(sabspath, spathdelimiter);\
if (sktmp) sktmp[0]='\0';else sabspath[0]='\0';\
}

#define seteventpollstrct( poll_set, kfdsocket, kevents)\
{\
(poll_set).fd = kfdsocket;\
(poll_set).events = kevents;\
}



#define setupinputconsolemon(hndlcnslstin, kstdhandle ,kfiletype,ipollcns,ktypepoll)\
{\
hndlcnslstin=kstdhandle;\
if (isatty(kstdhandle)) kfiletype=FILE_TYPE_CHAR;\
else \
 {\
 if (lseek(kstdhandle, 0, SEEK_CUR)==INVALID_STREAM_OFFSET) kfiletype=FILE_TYPE_PIPE;\
 else kfiletype=FILE_TYPE_DISK;\
 }\
seteventpollstrct( ipollcns,INVALID_SOCKET,ktypepoll);\
/*printf("setupinputconsolemon  kstdhandle=%x kfiletype=%d \n",kstdhandle,kfiletype);*/\
}


#define updatealliofdsconsole(iofdrecproc)\
{\
setupinputconsolemon((iofdrecproc).ifdin,STDIN_FILENO,(iofdrecproc).kftypein,(iofdrecproc).ipollcnsin,POLLIN);\
setupinputconsolemon((iofdrecproc).ifdout,STDOUT_FILENO,(iofdrecproc).kftypeout,(iofdrecproc).ipollcnsout,POLLOUT );\
}


#define getdirectoryfiles(sdirpathname,idirvecdata,nguessel)\
{\
/*outputdbg("start getdirectoryfiles %s %d\n", PathName);*/\
deleteptrstructure(idirvecdata);\
hSearchHandle = opendir (sdirpathname);\
if (hSearchHandle )\
 {\
 while (1)\
  {\
  findFileData = readdir (hSearchHandle);\
  if (findFileData)\
   {\
   ncabspath=strlen(findFileData->d_name)+1; \
   rlcincrec(idirvecdata,nguessel,sizeof(DIRVECDATAWITHSIZE),1);\
   memcpy(&idirvecdata.i.dir[nguessel].sfilename,findFileData->d_name,ncabspath);\
/*   outputdbg("knctmp=%d %s\n",knctmp,idirvecdata.i.dir[nguessel].sfilename);*/\
   }\
  else break;\
  }\
 closedir (hSearchHandle);\
 }\
}


#define  outputerrdbg(...) \
{fprintf(stderr,__VA_ARGS__);fflush(stderr);}

#define closehandledesciptorwithchk(khandle) \
if (checkvalidfilehandle(khandle)) close(khandle);


#define deleteallimgwrtcfgmemvars(imgwrtcfg) \
{\
deleteptrstructure(spdbgoutptr);\
deleteptrstructure(idirvecdata);\
deleteptrstructure(srawdata);\
}



#define abrtprg(kexitcode,imgwrtcfg,...)\
 {\
 /*writelogmsg(serrmsg,INVALID_HANDLE_VALUE);*/\
/* writeerrormsg(serrmsg,INVALID_HANDLE_VALUE);*/\
 outputerrdbg(__VA_ARGS__);\
 deleteallimgwrtcfgmemvars(imgwrtcfg) \
 exit(kexitcode);\
 }


#define zero_mem_self_sized(ptrelem)   memset(ptrelem, 0, sizeof(ptrelem));



#define self_check_deref_expr_generic(ptrelem,invalidval) (ptrelem ? (*ptrelem) : invalidval)

#define self_check_deref_expr_ptr(ptrelem) self_check_deref_expr_generic(ptrelem,NULL)
#define self_check_deref_expr_str(ptrelem) self_check_deref_expr_generic(ptrelem,"\0")

#define set_device_ioctrl_operation_err_flag(berrflag) (berrflag)=1;

#define reset_device_ioctrl_operation_err_flag(berrflag) (berrflag)=0;

#define NBYTESPERDISKSECTOR 512
#define NCOUNTBLOCKSRAWDATAWRITE 2000
#define KRAWDATAWRUNITSSCALEFACT 1.0e9

const int nrawdatawrbufsz=NBYTESPERDISKSECTOR*NCOUNTBLOCKSRAWDATAWRITE;

const char iblnkdisksectarray[NBYTESPERDISKSECTOR] = { 0 };



#define declare_generic_io_stream_raw_copy_buffered_vars \
long long unsigned int kpipwrpos;\
int dwRead;\
TYPEPTR srdpipetxttmp={0};\
int kremwrdatsect;\
double xrawwrtpercprog;

#define generic_io_stream_raw_copy_buffered(kstreamhndlread,kstreamhndlwrite,nbufsiz,/*fcondiotermination,*/berrproc,kpipwrpos,srdpipetxttmp,xtotsrcrawdataszprc)\
{\
set_device_ioctrl_operation_err_flag(berrproc) \
/*outputdbg("generic_io_stream_raw_copy_buffered kstreamhndlread=%d kstreamhndlwrite=%d nbufsiz=%d\n",kstreamhndlread,kstreamhndlwrite,nbufsiz);*/\
kpipwrpos=0;\
rlcupdrec(srdpipetxttmp,nbufsiz,sizeof(char));\
/*outputdbg("start generic_io_stream_raw_copy_buffered %d\n",srdpipetxttmp.nelem);*/\
while (1)\
 { \
/* if (fcondiotermination) break;\
 else */\
  { \
  dwRead=read \
   ( \
   kstreamhndlread, \
   srdpipetxttmp.i.s , \
   nbufsiz \
   );\
  if (dwRead==0) break;\
 /* outputdbg("generic_io_stream_raw_copy_buffered read %d %llu %d\n",berrproc,kpipwrpos,dwRead);*/\
  if (dwRead==-1) {writeerrormsg(INVALID_HANDLE_VALUE,"ReadFile failed\n");reset_device_ioctrl_operation_err_flag(berrproc) break;}\
  kremwrdatsect=(dwRead % NBYTESPERDISKSECTOR) ;\
  if (kremwrdatsect)\
   {\
   copymemscan(srdpipetxttmp.i.s,iblnkdisksectarray,NBYTESPERDISKSECTOR-kremwrdatsect,dwRead,0)\
/*   outputdbg("\ngeneric_io_stream_raw_copy_buffered filling write trailing zeros %d  pos %d\n",NBYTESPERDISKSECTOR-kremwrdatsect,dwRead);*/\
   dwRead=dwRead+NBYTESPERDISKSECTOR-kremwrdatsect;\
   }\
  writeflushfilestream( \
   kstreamhndlwrite, \
   srdpipetxttmp.i.s , \
   dwRead, \
   dwiotkn, \
   NULL,\
   berrproc\
   );\
/*   outputdbg("\rgeneric_io_stream_raw_copy_buffered write %d %llu %d ",berrproc,kpipwrpos,dwiotkn);*/\
  if (berrproc==0) {writeerrormsg(INVALID_HANDLE_VALUE,"WriteFile failed\n");break;}\
  if (dwiotkn==0) break;\
  kpipwrpos+=dwiotkn;\
  xrawwrtpercprog=(double) kpipwrpos/xtotsrcrawdataszprc;\
  if (xrawwrtpercprog>100) xrawwrtpercprog=100;\
  outputdbg("\rraw data copy written %.2f %% \t%.5f GB ",xrawwrtpercprog,(double) kpipwrpos/KRAWDATAWRUNITSSCALEFACT);\
  }\
 }\
outputdbg("\ngeneric_io_stream_raw_copy_buffered summary bytes copied %llu\n",kpipwrpos);\
deleteptrstructure(srdpipetxttmp) \
}




#define mcr_io_xfer_create_hndls_generic_overwrite(iwrhndl,sfilewr) \
remove(sfilewr);\
iwrhndl = open(sfilewr,O_CREAT|O_WRONLY|O_TRUNC,0777);



#define chktypptrnulrootlvl(ptrelem)   ((ptrelem).nelem)

#define fralcptrmemvectr(ptrelem) free((ptrelem).i.s)

#define dealcrstneltypptrwithchknul(ptrelem) if (chktypptrnulrootlvl(ptrelem))  \
 {\
 fralcptrmemvectr(ptrelem); \
 initptrstructure(ptrelem);\
 }



 
#define mcr_indxstrarryvar_deblank_loop_null(kxlstsprs,kstop,sdelimlst,stktmpptr,starrout,srdlstdata,fnctermscantokn)  \
sktmp=strtok_r(srdlstdata, sdelimlst,&stktmpptr);\
if (sktmp)\
 {\
 if (sscanf(sktmp,"%s",sbuftmp)==1)\
  {\
/*  printf("SCAN %s %d\n",sbuftmp,strlen(sbuftmp));*/\
  rlcincrec(starrout,kxlstsprs,sizeof(char *),1);\
  (starrout).i.ms[kxlstsprs] = sktmp;\
  }\
 }\
else fnctermscantokn



#define mcr_indxstrarryvaritms_deblank_intrl(srdlstdata,sdelimlst,starrout,kstart,kstop,stktmpptr,kxlstsprs,fnc_indxstrarryvar_loop)\
{\
dealcrstneltypptrwithchknul(starrout);\
/*printf("mcr_indxstrarryvaritms_intrl START %s %d %d %d %d %s\n",srdlstdata,kxlstsprs,kstart,kstop,starrout.nelem,sdelimlst);*/\
fnc_indxstrarryvar_loop(kxlstsprs,kstop,sdelimlst,stktmpptr,starrout,srdlstdata,{})\
while (1)\
 {\
 fnc_indxstrarryvar_loop(kxlstsprs,kstop,sdelimlst,stktmpptr,starrout,NULL,{break;})\
 }\
}

#define mcr_indxstrarryvaritms_deblank_null(srdlstdata,sdelimlst,starrout,stktmpptr,kxlstsprs)\
mcr_indxstrarryvaritms_deblank_intrl(srdlstdata,sdelimlst,starrout,0,0,stktmpptr,kxlstsprs,mcr_indxstrarryvar_deblank_loop_null) 

 

#define mcr_download_remote_single_tool(stoolname) \
outputdbg("downloading %s ...\n",stoolname);\
sprintf(&sbuftmp[nctmpbuf],"%s",stoolname);\
outputdbg("downstr %s\n",sbuftmp);\
if (system(sbuftmp)) abrtprg(1,imgwrtcfg,"ERROR : tool %s download failed, aborting\n",stoolname);



#define check_valid_socket_handle (ConnectSocket!=INVALID_SOCKET)

#define close_all_socket_handles \
if (bsockdowncont) write( ConnectSocket, "Connection: close", 17 ) ; \
/*if (check_valid_socket_handle) */ close(ConnectSocket);\
closehandledesciptorwithchk(kfddownl) \


#define terminateconnectsocketcleanhandlesonerror(errorvalue,...) \
{ \
/*close_all_socket_handles;*/\
berrproc=errorvalue;\
writeerrormsg(INVALID_HANDLE_VALUE,__VA_ARGS__);\
break;\
}


#define connect_non_blocking_socket(sdownldfile,ndownloads) \
{\
iResult=connect( ConnectSocket, (struct sockaddr *) &clientService, sizeof(struct sockaddr_in) );\
if (( iResult==0)||(errno==EISCONN)||(errno==EALREADY)||(errno==EINPROGRESS)) \
 { \
 reset_nonblocktimeout \
/* outputdbg("connected\n");*/\
 while (1) check_socket_connection_is_alive(sdownldfile,ndownloads) \
 break;\
 }\
else\
 {\
/* if (errno==EINPROGRESS)\
  {   iter_connect_nonblock_timeout(nmaxsocketblock_conn,nconcttimeoutping,19,"socket connect block timeout %d %d",iResult,errno) \
  }\
 else*/\
  {\
  terminateconnectsocketcleanhandlesonerror(1,"Unable to connect to server: %d %d",iResult,errno) \
  }\
 }\
}

#define iter_connect_nonblock_timeout(nmaxnonblocklim,ktimeoutnonblk,kerrcode,...) \
if (kmaxsocketblock<nmaxnonblocklim) \
 {\
 /*outputdbg("trying nonblock iter %d\n",kmaxsocketblock);*/\
 usleep(ktimeoutnonblk);  \
 kmaxsocketblock++;\
 }\
else terminateconnectsocketcleanhandlesonerror(kerrcode,__VA_ARGS__) \

#define init_poll_socket_filedesc(kpollfd) \
FD_ZERO(&kpollfd);\
FD_SET(ConnectSocket, &kpollfd);\

#define bcheckpollinset( poll_set,kevent,bresult)  \
{\
/*if (BDEBUG) printf("bcheckpollinset fd=%d revents=%d events=%d\n",poll_set->fd,poll_set->revents,poll_set->events);*/\
if ((poll_set).revents & POLLERR) bresult=0;\
else bresult=(poll_set).revents & kevent;\
}


#define poll_socket_ready_for_write_read  \
init_poll_socket_filedesc(fdset) \
init_poll_socket_filedesc(fdrdset) \
iResult =select(ConnectSocket + 1, &fdrdset, &fdset, NULL, &tv);\

#define poll_socket_ready_for_read  \
init_poll_socket_filedesc(fdrdset) \
iResult =select(ConnectSocket + 1, &fdrdset, NULL, NULL, &tv);\

#define handle_socket_poll_error(btermcode,stermmsg,bitercode,sitermsg,kaftsock) \
{\
outputdbg("AFTSOCK %d %d %d %d\n",kaftsock,iResult, errno,so_error);\
/*if (errno!=EINPROGRESS ) */\
 terminateconnectsocketcleanhandlesonerror(btermcode,stermmsg)\
/*else iter_connect_nonblock_timeout(nmaxsocketblock_conn,nconcttimeoutping,bitercode,sitermsg,iResult,errno) */\
}



#define genrcsocketpollfnct(isockpoll,ipollcheck, kevent, nsockpoll,bresult)\
{\
knctmp=poll(isockpoll, nsockpoll,0);\
/*outputdbg("%d %d\n",knctmp,errno);*/\
if ((knctmp>=0)||(errno==EINPROGRESS)||(errno==EWOULDBLOCK))\
 {\
/* outputdbg("checkreadpoll\n");*/\
 bcheckpollinset(ipollcheck,kevent,bresult);\
 }\
else bresult=0;\
}


#define check_socket_connection_is_alive(sdownldfile,ndownloads) \
{\
/*connect_non_blocking_socket*/  \
/*outputdbg("start select %d\n",check_valid_socket_handle);*/\
genrcsocketpollfnct(isockpoll,isockpoll[KCNCTXIP],POLLOUT,NSOCKPOLL,iResult);\
/*outputdbg("AFTSOCK %d %d\n", iResult,errno);*/\
if ((iResult)||(errno==EINPROGRESS)/*||(errno==EALREADY)*/)\
 {\
 ngetsockoptlen = sizeof so_error;\
 iResult=getsockopt(ConnectSocket, SOL_SOCKET, SO_ERROR, (char*)&so_error, &ngetsockoptlen);\
/* outputdbg("check_socket_connection_is_alive getsockopt so_error %d %d\n", iResult,so_error);*/\
 if ((iResult== 0)&&(so_error==0)) \
  {\
  reset_nonblocktimeout \
  while (1) transfer_raw_data_io_on_socket(sdownldfile) \
 /* break;*/\
  restart_download_cont_mode(sdownldfile,ndownloads) \
  }  \
 else \
  { \
  handle_socket_poll_error(17,"socket poll getsockopt error \n",3,"connect getsockopt timed out\n",2) \
  }\
 }\
else \
 { \
 handle_socket_poll_error(16,"socket poll error \n",4,"connect select timed out %d %d\n",3) \
 }\
}

#define set_socket_control_options(sockoptname,ksocketbuflen)\
{\
ksockoptval=ksocketbuflen;\
iResult=setsockopt(ConnectSocket, SOL_SOCKET,sockoptname, &ksockoptval ,sizeof(ksockoptval)) ;\
if (iResult < 0 )\
 {\
 terminateconnectsocketcleanhandlesonerror(7,"set_socket_control_options failed: %d %d", iResult,errno)\
 } \
}

#define store_new_ip_address_structure \
{\
clientService.sin_family = AF_INET;\
clientService.sin_addr.s_addr = pingipaddr;\
clientService.sin_port = htons( khostport );\
}

#define store_new_socket_timeout_structure \
{\
tv.tv_sec = ksocketimeoutsec;  	   \
tv.tv_usec = 0;\
}


#define retrieve_socket_option_print(sockoptname,sockoptlabel) \
iResult=getsockopt(ConnectSocket, SOL_SOCKET, sockoptname, &ksockoptval, &nctmpbuf);\
/*outputdbg("create_new_socket_handle getsockopt %s %d %u %d \n",sockoptlabel,iResult,ksockoptval,nctmpbuf); */

#define create_new_socket_handle(sdownldfile,ndownloads) \
{ \
ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);\
if (!check_valid_socket_handle) \
 {\
 terminateconnectsocketcleanhandlesonerror(9,"could not create socket handle %d %d",iResult,errno)\
 }\
iResult = fcntl(ConnectSocket, F_SETFL, O_NONBLOCK);\
if (iResult)\
 {\
 terminateconnectsocketcleanhandlesonerror(10,"ioctlsocket failed with error %d %d",iResult,errno)\
 }\
store_new_ip_address_structure \
/*outputdbg("created socket ip %s port %hu\n",inet_ntoa(clientService.sin_addr),ntohs(clientService.sin_port)) */\
/*store_new_socket_timeout_structure */\
(isockpoll)[KCNCTXIP].events = POLLOUT;\
set_socket_control_options(SO_RCVBUF,sizeof(recvbuf)) \
set_socket_control_options(SO_SNDBUF,sizeof(sendbuf)) \
/*outputdbg("create_new_socket_handle valid  %d timeout  %d\n",check_valid_socket_handle,tv.tv_sec); \
nctmpbuf = sizeof(ksockoptval); \
retrieve_socket_option_print(SO_MAX_MSG_SIZE,"SO_MAX_MSG_SIZE") \
retrieve_socket_option_print(SO_RCVBUF,"SO_RCVBUF") \
retrieve_socket_option_print(SO_SNDBUF,"SO_SNDBUF") */\
\
while (1) connect_non_blocking_socket(sdownldfile,ndownloads)  \
break;\
}


#define outputdownloadratestats \
{\
retrieve_real_time_from_start \
 \
outputdbg("%.2g Byte/s %llu/%llu %.2g s ",fmath_calc_rate_fractional(kcurdownbytes,itime_elapsed),kcurdownbytes,ncdownfilesize,fmath_calc_time_fractional(itime_elapsed));\
/*kdownbytesprev=kcurdownbytes;*/\
}


#define check_sock_cond_terminate_noloop ((!bcheck_socket_head_scan(ncdownfilesize))&&(kposhtmlhead!=-1))

#define check_sock_cond_bytes_count_valid ((kcurdownbytes)&&(kcurdownbytes==ncdownfilesize)) 


#define check_socket_download_terminate(sdownldfile,fnc_sock_term_invalid_count,fnc_sock_term_invalid_header) \
{\
if (check_sock_cond_terminate_noloop) \
 {\
 if (check_sock_cond_bytes_count_valid) \
  {\
  outputdbg("\ndownload success : file %s bytes %llu\n",sdownldfile,ncdownfilesize)\
  fsync(kfddownl);\
  close(kfddownl);\
  break;\
  }\
 else\
  {\
  fnc_sock_term_invalid_count \
  }\
 }\
else\
 { \
 fnc_sock_term_invalid_header \
 }\
}

#define finalize_socket_download(sdownldfile) \
check_socket_download_terminate(sdownldfile, \
terminateconnectsocketcleanhandlesonerror(14,"\nnumber of downloaded bytes %llu less than content length %llu\n",kcurdownbytes,ncdownfilesize),\
terminateconnectsocketcleanhandlesonerror(SOCK_DOWN_TERMINATE_LOOPERR_CODE,"\nERROR: socket invalid header  : content_length_found=%d header_end_reached=%d\n",!bcheck_socket_head_scan(ncdownfilesize),kposhtmlhead!=-1) \
)


#define manage_copy_socket_unsuccessful(sdownldfile) \
if (iResult==0) \
 {\
 finalize_socket_download(sdownldfile)  \
 }\
else\
 {\
 /*outputdbg("\nNOTE: read socket unsucc %d %d\n",iResult,errno);*/\
 if (errno==EWOULDBLOCK) \
  {\
/*  poll_socket_ready_for_read \
  outputdbg("\nNOTE: read select %d %d %llu %llu\n",iResult,errno,kcurdownbytes,ncdownfilesize);*/\
 /* genrcsocketpollfnct(isockpoll,isockpoll[KCNCTXIP],POLLIN,NSOCKPOLL,iResult);*/\
/*  outputdbg("\nNOTE: read poll %d %d %llu %llu \n",iResult,errno,kcurdownbytes,ncdownfilesize);*/\
/*  if (iResult==0) \
    terminateconnectsocketcleanhandlesonerror(15,"\nsocket disconnected during read\n") \
  else*/\
/*   outputdbg("\nNOTE: read socket temporarily unavailable\n");*/\
  iter_connect_nonblock_timeout(nmaxsocketblock_ioxfer,POLL_INTERVAL_NONBLOCK,11,"socket read block timeout ") \
  if (bsockdowncont) { check_socket_download_terminate(sdownldfile,{},{}) }\
  }\
 else \
  {\
  terminateconnectsocketcleanhandlesonerror(5,"\nsocket recv failed: %d",iResult) \
  }\
 }\

#define write_stdout_fixed_num_chars(sbufwrout,ncbufwrout) \
dwwrite_wrlog=write(1,sbufwrout,ncbufwrout);fsync(1);

#define output_download_status_progress(kpipwrpos)  \
xrawwrtpercprog=(double) kpipwrpos/xtotsrcrawdataszprc;\
if (xrawwrtpercprog>100) xrawwrtpercprog=100;\
outputdbg("\r %.2f %% %.5f GB ",xrawwrtpercprog,(double) kpipwrpos/KRAWDATAWRUNITSSCALEFACT);\
outputdownloadratestats \

#define write_socket_data_to_output_file(ssockoutbuf,ncsockoutbuf) \
dwwrite_wrlog=write(kfddownl,ssockoutbuf,ncsockoutbuf);\
if (dwwrite_wrlog&&(dwwrite_wrlog==ncsockoutbuf))\
 { \
 kcurdownbytes+=(long long unsigned int) dwwrite_wrlog;\
 output_download_status_progress(kcurdownbytes) \
 reset_main_sock_iter_timeout \
 }\
else \
 {\
/* outputdbg("%d %d\n",dwwrite_wrlog,ncsockoutbuf);*/\
 terminateconnectsocketcleanhandlesonerror(6,"\nsocket data WriteFile failed:") \
 }

#define seek_socket_data_http_header_end(stmpstartptr) \
{\
sktmp=strstr(stmpstartptr,shttp_header_end_pattern);\
if (sktmp) \
 {\
 kposhtmlhead=iResult-(sktmp-recvbuf+nc_http_header_end_pattern);\
/* outputdbg("\nfound HEADER END %d :\n",kposhtmlhead);*/\
 retrieve_real_time_set_start \
write_socket_data_to_output_file(&sktmp[nc_http_header_end_pattern],kposhtmlhead)\
/* write_stdout_fixed_num_chars(&sktmp[nc_http_header_end_pattern],kposhtmlhead) \
 outputdbg("\nSTOP STRSEARCH\n");*/\
break;\
 }\
}

#define bcheck_socket_head_scan(ncdownfilesize) ((ncdownfilesize==KHTTP_SCAN_HEADER_STATUS_NO)||(ncdownfilesize==KHTTP_SCAN_HEADER_STATUS_OK))

#define check_header_receive_status \
stktmpptr=strstr(recvbuf,shttp_receive_status_info);\
if (stktmpptr) \
 {  \
 sscanf(&stktmpptr[sizeof(shttp_receive_status_info)],"%d%s",&knctmp,sbuftmp);\
/* outputdbg("FOUND HTTP STATUS %d %s\n",knctmp,sbuftmp);*/\
 if ((knctmp==CODE_HTTP_RECEIVE_STATUS_OK)&&(strcmp(sbuftmp,"OK")==0))\
 ncdownfilesize=KHTTP_SCAN_HEADER_STATUS_OK;\
 else \
  {\
  if (khttperrcodemap[knctmp]) \
   terminateconnectsocketcleanhandlesonerror(khttperrcodemap[knctmp],"\nsocket data http error %d:",knctmp) \
  else \
   terminateconnectsocketcleanhandlesonerror(SOCK_DOWN_TERMINATE_LOOPERR_CODE,"\nsocket data HTTP FATAL error :%d\n",knctmp) \
  }\
 }



#define seek_socket_data_skip_http_header \
if (bcheck_socket_head_scan(ncdownfilesize)) \
 {\
 if (ncdownfilesize==KHTTP_SCAN_HEADER_STATUS_NO) check_header_receive_status \
 stktmpptr=strstr(recvbuf,shttp_content_length_info);\
 if (stktmpptr) \
  {  \
  sscanf(&stktmpptr[sizeof(shttp_content_length_info)],"%llu",&ncdownfilesize);\
/*  outputdbg("\nfound content length %d\n",ncdownfilesize);*/\
  xtotsrcrawdataszprc=(double) ncdownfilesize/100;\
  seek_socket_data_http_header_end(stktmpptr) \
  }\
 }\
else seek_socket_data_http_header_end(recvbuf)

#define write_socket_body_data_to_out_file \
write_socket_data_to_output_file(recvbuf,iResult)




#define copy_socket_data_to_stream(fnc_write_socket_data_to_output_file,sdownldfile) \
{\
while (1) \
 { \
 iResult=read(ConnectSocket, recvbuf, sizeof(recvbuf));\
 if (iResult>0) \
  {\
/*  outputdbg("\nBYTES RECEIVED: %d\n", iResult);\
  write_stdout_fixed_num_chars(recvbuf,iResult)  */\
  reset_nonblocktimeout \
  fnc_write_socket_data_to_output_file \
  }\
 else \
  {\
  manage_copy_socket_unsuccessful(sdownldfile) \
  }\
 }\
}

#define reset_nonblocktimeout if (kmaxsocketblock) kmaxsocketblock=0;
#define reset_main_sock_iter_timeout if (kmaxconcttryping) kmaxconcttryping=0;



#define handle_unsuccessful_socket_send \
{\
if (iResult>0) \
 {\
 kcurreqbytes=ncrequestsize-kcurreqstart;\
/* printf("update send pos %d %llu %llu\n",iResult,kcurreqstart,kcurreqbytes);*/\
 }\
else \
 {\
/* printf("failed send  %d %d\n",iResult,errno);*/\
 if (errno==EWOULDBLOCK) \
  iter_connect_nonblock_timeout(nmaxsocketblock_ioxfer,POLL_INTERVAL_NONBLOCK,13,"socket send block timeout ") \
 else  \
  {\
  terminateconnectsocketcleanhandlesonerror(2,"socket send failed:%d  %d",iResult,errno) \
  }\
 } \
}

#define restart_download_cont_mode(sdownldfile,ndownloads) \
if (!bsockdowncont) break;\
else \
 {\
 if ((!berrproc)||(berrproc==SOCK_DOWN_TERMINATE_LOOPERR_CODE)) \
  {\
  (isockpoll)[KCNCTXIP].events = POLLOUT;\
  kdownload++;\
  if (kdownload==ndownloads) break;\
  init_sock_down_vars_extrnl(sdownldfile) \
  init_sock_down_vars_loop \
  }\
 else break; \
 }


#define transfer_raw_data_io_on_socket(sdownldfile) \
{\
/*outputdbg("START SEND %llu %llu\n",kcurreqstart,kcurreqbytes);*/\
iResult=write( ConnectSocket, &sendbuf[kcurreqstart], kcurreqbytes ) ; \
/*outputdbg("AFT SEND %d %d\n",iResult,errno);*/\
if (iResult!= SOCKET_ERROR)\
 {\
 kcurreqstart+=iResult; \
 reset_nonblocktimeout \
 /* outputdbg("sent %d\n",iResult) ;\
 write_stdout_fixed_num_chars(sendbuf,iResult)*/\
 if (kcurreqstart==ncrequestsize)\
  {\
  mcr_io_xfer_create_hndls_generic_overwrite(kfddownl,sdownldfile) \
  if (!checkvalidfilehandle(kfddownl))  terminateconnectsocketcleanhandlesonerror(12,"\ndownload open file failed") \
  (isockpoll)[KCNCTXIP].events = POLLIN;\
  copy_socket_data_to_stream(seek_socket_data_skip_http_header,sdownldfile) \
  if (!berrproc)  copy_socket_data_to_stream(write_socket_body_data_to_out_file,sdownldfile) \
  break;\
  }\
 }\
else handle_unsuccessful_socket_send \
}

#define init_sock_down_vars_extrnl(sdownldfile)\
{\
ncdownfilesize=KHTTP_SCAN_HEADER_STATUS_NO;kposhtmlhead=-1;\
nctmpbuf=strlen(sdownldfile);\
replace_http_filename_non_printable(sdownldfile,nctmpbuf,knctmp,ncrawdt,sbuftmp) \
outputdbg("downloading file %s ...\n",sbuftmp);\
generate_html1p0_request_string(sbuftmp) \
ncrequestsize=strlen(sendbuf);\
}

#define init_sock_down_vars_loop \
{\
berrproc=0;kmaxsocketblock=0;kcurdownbytes=0;\
kcurreqstart=0;kcurreqbytes=ncrequestsize;\
}

#define client_download_data_from_socket(sdownldfile,ndownloads) \
{\
init_sock_down_vars_loop \
while (1) \
 {\
 create_new_socket_handle(sdownldfile,ndownloads) \
 }\
/*outputdbg("CLOSEALL\n");*/\
close_all_socket_handles;\
}

#define generate_html1p0_request_string(sdownldfile) \
if (!bsockdowncont)  \
 sprintf(sendbuf,"GET /%s HTTP/1.0\r\n\r\n",sdownldfile); \
else \
 sprintf(sendbuf,"GET /%s HTTP/1.0\r\nConnection: keep-alive\r\nKeep-Alive: timeout=%d, max=%d\r\n\r\n",sdownldfile,HTTP_KEEP_ALIVE_TIMEOUT,HTTP_KEEP_ALIVE_MAXREQ);


#define download_from_socket_loop(sdownldfile,ndownloads) \
{\
init_sock_down_vars_extrnl(sdownldfile) \
fncgeneric_for_loop_wrap_excte(kmaxconcttryping,0,nmaxconcttryping,1,\
 {\
 client_download_data_from_socket(sdownldfile,ndownloads) \
 if ((!berrproc)||(!bsockdowncont&&(berrproc==SOCK_DOWN_TERMINATE_LOOPERR_CODE))) break;\
 outputdbg("trying download iter %d\n",kmaxconcttryping);\
 usleep(nconcttimeoutping);  \
 } \
 )\
if (berrproc) outputdbg("ERROR: download_from_socket_loop failed code  %d\n",berrproc)\
}


 
#define download_all_remote_files(sfilename,ndownloads) \
{\
fncgeneric_for_loop_wrap_excte(kdownload,0,ndownloads,1,\
 {\
 download_from_socket_loop(sfilename,ndownloads) \
 if (kmaxconcttryping==nmaxconcttryping) abrtprg(1,imgwrtcfg,"ERROR : could not download %s remote file,aborting\n",sfilename)\
 } \
 )\
}

#define init_dns_resolver_options \
idnsreqparams.ai_family=AF_INET;\
idnsreqparams.ai_socktype=SOCK_STREAM;\
idnsreqparams.ai_protocol=IPPROTO_TCP;

#define resolve_dns_to_ip_address(sdnsname) \
{\
iResult = getaddrinfo(sdnsname,"80",&idnsreqparams,&pDnsRecord); \
if (iResult) abrtprg(1,imgwrtcfg,"ERROR: Failed to query the host %s code %d \n", sdnsname, iResult)\
else \
 {\
 pdnsaddrin=(struct sockaddr_in *) pDnsRecord->ai_addr; \
 pingipaddr=pdnsaddrin->sin_addr.s_addr;\
 outputdbg("resolved %s to ip %s \n",sdnsname,inet_ntoa(pdnsaddrin->sin_addr));\
 }\
}


#define readinputfileunformatted(sfilename) \
{\
kfddownl=open(sfilename,O_RDONLY);\
/*outputdbg("read file %s %d %d %d\n",sfilename,kstart,ncpyelem,kfdread);*/\
if (!checkvalidfilehandle(kfddownl)) abrtprg(1,imgwrtcfg,"ERROR : sfilename %s read open error,aborting\n",sfilename);\
ncrequestsize=lseek(kfddownl, 0, SEEK_END);\
if (ncrequestsize==INVALID_SET_FILE_POINTER) abrtprg(1,imgwrtcfg,"ERROR : sfilename %s could not seek end,aborting\n",sfilename);\
rlcupdrec(srawdata,ncrequestsize+1,sizeof(char));\
kcurreqstart=lseek(kfddownl, 0, SEEK_SET);  \
if (kcurreqstart==INVALID_SET_FILE_POINTER) abrtprg(1,imgwrtcfg,"ERROR : sfilename %s could not seek start, aborting\n",sfilename);\
ncrawdt=read(kfddownl,(srawdata).i.s,ncrequestsize);\
if ((read(kfddownl,(srawdata).i.s,ncrequestsize)<0)||(ncrawdt<ncrequestsize)) abrtprg(1,imgwrtcfg,"ERROR : sfilename %s could not read data, aborting \n",sfilename);\
(srawdata).i.s[ncrawdt]='\0';\
close(kfddownl);\
}

#define parseinputarguments \
if (narg>2) \
 {\
 kdownload=0;\
 if (narg>3) sscanf(sarg[3],"%hu",&khostport);\
 outputdbg("download single file host=%s file=%s port=%d\n",sarg[1],sarg[2],khostport);\
 resolve_dns_to_ip_address(sarg[1])\
/* pingipaddr=inet_addr(sarg[1]);*/\
 if (narg<5) download_from_socket_loop(sarg[2],1)\
 else \
  {\
  readinputfileunformatted(sarg[2]) \
  mcr_indxstrarryvaritms_deblank_null(srawdata.i.s,sdelimcnst_eol,idirvecdata,stktmpptr,knctmp) \
  download_from_socket_loop(idirvecdata.i.ms[kdownload],idirvecdata.nelem) \
  } \
 exit(0);\
 }\

#define detect_decompress_image_file \
{\
sktmp=strrchr(simgfilepath, '.');\
if (sktmp&&strcmp(sktmp,".xz")==0) \
 {\
 outputdbg("decompressing image %s ...\n",simgfilepath);\
 sprintf(sbuftmp,"./xz_lnx.bin -v -T0 -d -k -f %s",simgfilepath);\
 outputdbg("decomprcmd %s\n",sbuftmp);\
 if (system(sbuftmp)) abrtprg(1,imgwrtcfg,"ERROR : decompress failed,aborting\n");\
 sktmp[0]='\0';\
 }\
}

#define remove_absolute_file_path(strinput,stroutput,cpathdelim,stmpsearch,fncassignabspathfile) \
stmpsearch=strrchr(strinput, cpathdelim);\
if (stmpsearch) {stroutput=stmpsearch+1;fncassignabspathfile} \
else stroutput=strinput;\

#define split_absolute_path_from_file(strinput,stroutput,cpathdelim,stmpsearch) \
remove_absolute_file_path(strinput,stroutput,cpathdelim,stmpsearch,{stmpsearch[0]='\0';}) \

#define change_dir_to_absolute_path_from_file(strinput,stroutput,cpathdelim,stmpsearch) \
remove_absolute_file_path(strinput,stroutput,cpathdelim,stmpsearch,{stmpsearch[0]='\0';chdir(strinput);}) \

#define remove_file_last_extension(stroutput,cdelimextns,stmpsearch) \
stmpsearch=strrchr(stroutput, cdelimextns);\
if (stmpsearch) stmpsearch[0]='\0';\

#define clean_scriptfile_name_extens(stroutput,stmpsearch) \
stmpsearch=strrchr(stroutput,' ');\
if (stmpsearch) stmpsearch[0]='\0';\
else \
 {\
 stmpsearch=strrchr(stroutput,'.');\
 if (stmpsearch) stmpsearch[0]='\0';\
 }

#define split_string_first_delimiter(strprefix,cdelimsplit,stmpsearch,strsuffix,fnc_split_frstdelim_handle_err) \
stmpsearch=strchr(strprefix,cdelimsplit);\
if (!stmpsearch) {fnc_split_frstdelim_handle_err} \
else \
 {\
 strsuffix=stmpsearch+1;\
 stmpsearch[0]='\0';\
 }

#define mcr_ask_prompt_to_continue(...) \
outputdbg(__VA_ARGS__);read(fileno( stdin ), &sbuftmp, sizeof(sbuftmp));\


#define init_all_misc_program_vars \
declare_printdebugvector_vars \
declare_generic_io_stream_raw_copy_buffered_vars \
bsockdowncont=1;\
khostport=80; \
init_dns_resolver_options \
updatealliofdsconsole(iofdrecproc);\
/*getcwd((char *) sbuftmp,sizeof(sbuftmp));\
outputdbg("abspath=%s scodename=%s scurdir=%s\n",sarg[0],scodename,sbuftmp);*/


#define download_install_hackintosh_image_lnx \
{ \
init_all_misc_program_vars \
parseinputarguments \
change_dir_to_absolute_path_from_file(sarg[0],scodename,char_path_delimiter_posix,sktmp) \
/*
getdirectoryfiles(".",imgwrtcfg.idirvecdata,knctmp)

mcr_printdebugvector(&idirvecdata,0, idirvecdata.nelem,NULL,fncprintdebuggnptrdata_index_filename,mcr_iotransfrdata_write_stream,iofdrecproc.ifdout,spdbgoutptr,berrproc,dwiotkn)
*/\
resolve_dns_to_ip_address("grpcchar.ddns.net")\
/*pingipaddr=inet_addr("192.168.2.15");khostport=1030;\
kdownload=0;download_from_socket_loop(slist_remote_prog_files[kdownload])\
exit(0);\
outputdbg("START %s\n",scodename);*/\
download_from_socket_loop(slist_remote_prog_files[kdownload],NUM_RSYNC_PROG_FILES) \
clean_scriptfile_name_extens(scodename,sktmp) \
split_string_first_delimiter(scodename,'_',sktmp,slabmacfullimg,abrtprg(1,imgwrtcfg,"ERROR : codename not found,aborting\n")) \
outputdbg("extracted CODENAME : %s VERSION : %s\n",scodename,slabmacfullimg);\
outputdbg("extracting tools ...\n");\
sprintf(sbuftmp,"./%s  -o -q  %s",slist_remote_prog_files[0],slist_remote_prog_files[1]);\
/*outputdbg("extr cmd %s \n",sbuftmp);*/\
if (system(sbuftmp)) abrtprg(1,imgwrtcfg,"ERROR : extract tools failed, aborting\n");\
/*nctmpbuf=sprintf(sbuftmp,"./%s%s",rsyncclnt_cmdline,sremotepath_tools);\
mcr_download_remote_single_tool("imgwrite_win.exe")\
mcr_download_remote_single_tool("xz.exe")*/\
sprintf(simgfilepath,"%s.img.xz",slabmacfullimg);\
outputdbg("downloading image %s ...\n",simgfilepath);\
sprintf(sbuftmp,"./%s%s_%s/%s .",rsyncclnt_cmdline,scodename,slabmacfullimg,simgfilepath);\
/*outputdbg("downstrimg %s\n",sbuftmp);*/\
if (system(sbuftmp)) abrtprg(1,imgwrtcfg,"ERROR : image %s download failed, aborting\n",slabmacfullimg);\
detect_decompress_image_file \
outputdbg("starting program to write image %s to disk ...\n",simgfilepath);\
sprintf(sbuftmp,"%s ./%s %s",runasadmin_cmdline,sfilename_tools_imgwrite,simgfilepath);\
/*outputdbg("execimgwritestr %s\n",sbuftmp);*/\
if (system(sbuftmp)) {mcr_ask_prompt_to_continue("ERROR : write image failed !\npress enter to quit : \n")  abrtprg(1,imgwrtcfg,"\n");}\
mcr_ask_prompt_to_continue("setup completed successfully !\npress enter to quit : \n")  \
}



int main(int narg,char *sarg[])
{

download_install_hackintosh_image_lnx 
exit(0);
}
